test.func_int = {}
test.func_int.ui = {}

local fi = test.func_int
local ui = test.func_int.ui

fi.minor = 'funcint'
fi.functions = {}
local ftbl = fi.functions

local fc = test.fontcolor
local stringify = test.stringify

local function hook(fname)
	local _, t = pcall(loadstring('return type('..fname..')'))
	if (t ~= 'function') then return nil end
	ftbl[fname].old = assert(loadstring('return '..fname))()
	local newfunc = [[	function(...)
		local fi = test.func_int
		local starttime
		local function printvals(valtype, ...)
			local endtime
			if (valtype == 'Returns') then endtime = gkmisc.GetGameTime() end
			local msg = ']]..fname..[[() '..valtype..':\n'
			for n = 1, select('#',...) do
				local e = select(n,...)
				local t = type(e)
				msg = msg..n..': ('..t..')\t'
				if (t == 'table') then
					if (e[']]..(fname:match('.*%.([%w_]+)') or fname)..[[']) then
						msg = msg.."]]..(fname:match('(.*)%.') or "** You shouldn't see this message **")..[[ ["..tostring(e)..']\n' --need double quotes on this line
					else
						msg = msg..test.stringify(e)..'\n'
					end
				else
					msg = msg..test.stringify(e)..'\n'
				end
			end
			msg = msg:gsub('\n$', '')
			if (endtime) then msg = ']]..fname..[[() Runtime: '..endtime - starttime..'ms\n'..msg end
			if (valtype == 'Arguments') then
				msg = string.rep('v', 35)..'\n'..msg
			else
				msg = msg..'\n'..string.rep('^', 30)
			end
			test.buffered_console_print(test.fontcolor..msg)
			if (valtype == 'Returns') then return ... end
		end
		printvals('Arguments', ...)
		starttime = gkmisc.GetGameTime()
		return printvals('Returns', fi.functions[']]..fname..[['].old(...))
	end]]
	return pcall(function() local r = assert(loadstring(fname..'='..newfunc))() return true end)
end

local function unhook(fname)
	assert(loadstring(fname..'= test.func_int.functions["'..fname..'"].old'))()
	ftbl[fname].old = nil
end

local function savelist()
	gkini.WriteString(test.config.major, fi.minor..'.list', stringify(ftbl, true))
end

function fi.add(fname)
	local msg

	if (ftbl[fname]) then 
		msg = 'The function '..fname..'() has already been intercepted.'
		OpenAlarm('Function Interceptor', msg, 'OK')
		return
	end

	ftbl[fname] = {}
	local result, errmsg = hook(fname)
	if (result) then
		ftbl[fname].toggle = true
		msg = fname..'() has been successfully added to the list.'
		print(fc..msg)
		savelist()
	else 
		if (result == false) then
			msg = 'The function '..fname..'() cannot be intercepted.\n'
		else
			msg = fname..' is not a function.'
		end
		OpenAlarm('Function Interceptor', msg, 'OK')
		ftbl[fname] = nil
	end
end

function fi.del(fname, silent)
	if (not ftbl[fname]) then return end

	local func = ftbl[fname]
	if (func.toggle) then fi.toggle(fname, true) end
	ftbl[fname] = nil
	savelist()
	if (not silent) then 
		local msg = fname..'() has been deleted from the list.'
		print(fc..msg) 
	end
end

function fi.delall()
	for k in pairs(ftbl) do
		fi.del(k, true)
	end
	local msg = 'All functions have been deleted from the list.'
	print(fc..msg)
end

function fi.list()
	local msg = ' function'..string.rep(' ', 41)..' | active\n'..
                string.rep('-', 70)..'\n'

	for k, v in pairs(ftbl) do
		msg = msg..string.format(' %-50s   %s\n', k, tostring(ftbl[k].toggle))
	end
	print(fc..'The list of hooked functions has been printed to the console.')
	console_print(msg)
end

function fi.toggle(fname, silent)
	local bool_map  = {[true] = 'ON', [false] = 'OFF'}
	if (not ftbl[fname]) then return end
	if (type(ftbl[fname].toggle) ~= 'boolean') then
		local _, t = pcall(loadstring('return type('..fname..')'))
		if (t ~= 'function') then 
			ftbl[fname].toggle = 'nil'
			print(fc..'This function does not currently exist.')
			return
		else
			ftbl[fname].toggle = false
		end
	end

	ftbl[fname].toggle = not ftbl[fname].toggle
	if (ftbl[fname].toggle) then
		hook(fname)
	else
		unhook(fname)
	end
	savelist()
	if (not silent) then
		local msg = fname..'() has been toggled '..bool_map[ftbl[fname].toggle]..'.'
		print(fc..msg)
	end
end

function fi.init()
	local saved = unspickle(gkini.ReadString(test.config.major, fi.minor..'.list', ''))
	for k, v in pairs(saved) do
		
		local _, t = pcall(loadstring('return type('..k..')'))
		if (t ~= 'function') then v.toggle = 'nil' 
		elseif (t == 'function' and v.toggle == 'nil') then v.toggle = false
		end
		ftbl[k] = v
		if (type(ftbl[k].old) ~= 'function' and v.toggle == true) then hook(k) end
	end
end
